
!WAStore class methodsFor: '*seaside-examples-store-magma' stamp: 'brp 10/28/2005 11:30'!
initialize

	| application |
	application := self registerAsApplication: 'store'.
	application configuration 
		addAncestor: WAMagmaConfiguration new.

	^ application! !

!WAStore class methodsFor: '*seaside-examples-store-magma' stamp: 'brp 10/28/2005 11:40'!
repositoryPath

	^ WAMagmaConfiguration new valueAt: #repositoryPath! !

!WAStore class methodsFor: '*seaside-examples-store-magma' stamp: 'kph 9/5/2006 19:33'!
workspace
	"WAStore workspace"
'"-----------------------------------------------------------------------------------------------------------------
 Create the Magma repository in a local directory (manually) 
(seaside/config MagmaControlPanel provides a gui for this step).
-----------------------------------------------------------------------------------------------------------------"
MagmaRepositoryController create: ''magma'' root: (WAStoreRepository new initializeRepository).

"-----------------------------------------------------------------------------------------------------------------
 Open the repository with a local session.
-----------------------------------------------------------------------------------------------------------------"
 
session := MagmaLocalLocation default newSession.  
session connectAs: ''brp''.

"-----------------------------------------------------------------------------------------------------------------
 Explore the repository
-----------------------------------------------------------------------------------------------------------------"
session root explore.
session root inventory size.			"40"
session root orders size.				"0"
session root inventory anyOne explore.

"-----------------------------------------------------------------------------------------------------------------
 Interrogate the inventory...
-----------------------------------------------------------------------------------------------------------------"
Transcript clear.
session root inventory do: [ :x | Transcript show: x; cr ].
(session root inventory where: [ :sushi | sushi title = ''Uni'' ]) do: [ :x | Transcript show: x; cr ].
(session root inventory where: [ :sushi | sushi title between: ''Sake'' and: ''Tai'']) do: [ :x | Transcript show: x; cr ].

"-----------------------------------------------------------------------------------------------------------------
 Close the repository.
-----------------------------------------------------------------------------------------------------------------"
session disconnectAndClose. 
session := nil. 
Smalltalk garbageCollect. MagmaSession allInstances. "should be #()"

"-----------------------------------------------------------------------------------------------------------------
 Initialise the WAStore application and start Comanche/Seaside
-----------------------------------------------------------------------------------------------------------------"
WAStore initialize.
WAKom startOn: 8080.

"-----------------------------------------------------------------------------------------------------------------
 Once you have made an order via WAStore, you can connect to the repository
 via the controller managed by WAMagmaSession.
-----------------------------------------------------------------------------------------------------------------"
session := MagmaLocalLocation default newSession.
session connectAs: ''brp''.

session root orders size.
(session root orders read: #date) anyOne.

session disconnect. session := nil.

"-----------------------------------------------------------------------------------------------------------------
 Stop Comanche/Seaside
-----------------------------------------------------------------------------------------------------------------"
WAKom stop.
MagmaRepositoryController initialize.  "closes all repositories."

"-----------------------------------------------------------------------------------------------------------------
 Delete the repository.
-----------------------------------------------------------------------------------------------------------------"
WAStoreRepository delete.
'
	openInWorkspaceWithTitle: 'The Sushi Store: Seaside meets Magma'


! !

!WAStoreTask methodsFor: '*seaside-examples-store-magma' stamp: 'brp 11/4/2005 12:19'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"Store the order in Magma"

	| order |
	order := WAOrder new
				cart: cart;
				shippingAddress: shippingAddress;
				billingAddress: billingAddress;
				creditCard: aCreditCard;
				yourself.

	self session commit: [ self session root orders add: order ].


! !
WAStore initialize!
